您的位置:首页 > 产品设计 > UI/UE

CodeForces 632D Longest Subsequence(数论)

2016-03-31 09:01 543 查看
题意:求一个最长子序列使得序列中的数的lcm小于m

思路:lcm与数的顺序没有关系,所以我们记录每个数出现的次数,然后类似筛法一样去找每一个数的因子有多少个就好了

#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e6+5;
int cnt[maxn];
int dp[maxn];
int a[maxn];
int main()
{
int n,m;
scanf("%d%d",&n,&m);
for(int i=1;i<=n;i++)
{
scanf("%d",&a[i]);
if(a[i]<=m)cnt[a[i]]++;
}
for(int i=m;i;i--)
for(int j=i;j<=m;j+=i)
dp[j]+=cnt[i];
long long ans1=-1,ans2=-1;
for(int i=1;i<=m;i++)
if(dp[i]>ans1)
ans1=dp[i],ans2=i;
cout<<ans2<<" "<<ans1<<endl;
for(int i=1;i<=n;i++)
if(ans2%a[i]==0)
cout<<i<<" ";
cout<<endl;

}


Description

You are given array a with n elements and the number m. Consider
some subsequence of a and the value of least common multiple (LCM) of its elements. Denote LCM as l. Find any longest subsequence
of a with the value l ≤ m.

A subsequence of a is an array we can get by erasing some elements of a. It is allowed to erase zero or all elements.

The LCM of an empty array equals 1.

Input

The first line contains two integers n and m (1 ≤ n, m ≤ 106)
— the size of the array a and the parameter from the problem statement.

The second line contains n integers ai (1 ≤ ai ≤ 109)
— the elements of a.

Output

In the first line print two integers l and kmax (1 ≤ l ≤ m, 0 ≤ kmax ≤ n)
— the value of LCM and the number of elements in optimal subsequence.

In the second line print kmax integers — the positions of the elements from the optimal subsequence in the ascending order.

Note that you can find and print any subsequence with the maximum length.

Sample Input

Input
7 8
6 2 9 2 7 2 3


Output
6 5
1 2 4 6 7


Input
6 4
2 2 2 3 3 3


Output
2 3
1 2 3
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: